//
//  VCEliminar.m
//  ControlStock
//
//  Created by Marcos on 5/24/13.
//  Copyright (c) 2013 Marcos. All rights reserved.
//

#import "VCEliminar.h"
#import "CJSONDeserializer.h"

@interface VCEliminar ()

@end

@implementation VCEliminar


@synthesize txtId, txtName, txtCodigo, txtCodBarras, txtPrecio, txtUnidad ,codresultText;
@synthesize rows;

- (void)viewDidLoad
{
    [super viewDidLoad];
    //scroller.frame = CGRectMake(0, 0, 320, 60);
    //[scroller setContentSize:CGSizeMake(1024, 768)];
	// Do any additional setup after loading the view, typically from a nib.
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(apareceElTeclado:)
                                                 name:UIKeyboardWillShowNotification
                                               object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(desapareceElTeclado:)
                                                 name:UIKeyboardWillHideNotification
                                               object:nil];
    [[self scrollView] setContentSize:[[self view] frame].size];
    
    UITapGestureRecognizer *tapRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(scrollViewPulsado)];
    [tapRecognizer setCancelsTouchesInView:NO];
    [[self scrollView] addGestureRecognizer:tapRecognizer];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    [[NSNotificationCenter defaultCenter] removeObserver:self
                                                    name:UIKeyboardWillShowNotification
                                                  object:nil];
    
    [[NSNotificationCenter defaultCenter] removeObserver:self
                                                    name:UIKeyboardDidHideNotification
                                                  object:nil];
}


- (void) scrollViewPulsado
{
    [[self view] endEditing:YES];
}


- (void) desapareceElTeclado:(NSNotification *)laNotificacion
{
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationDuration:0.3];
    UIEdgeInsets edgeInsets = UIEdgeInsetsZero;
    [[self scrollView] setContentInset:edgeInsets];
    [[self scrollView] setScrollIndicatorInsets:edgeInsets];
    [UIView commitAnimations];
}


- (void) apareceElTeclado:(NSNotification *)laNotificacion
{
    //Obtenemos el tamaño del teclado
    NSDictionary *infoNotificacion = [laNotificacion userInfo];
    CGSize tamanioTeclado = [[infoNotificacion objectForKey:UIKeyboardFrameBeginUserInfoKey] CGRectValue].size;
    
    //Modificamos el tamaño de la 'ventana' de nuestro scroll view
    UIEdgeInsets edgeInsets = UIEdgeInsetsMake(0, 0, tamanioTeclado.height, 0);
    [[self scrollView] setContentInset:edgeInsets];
    [[self scrollView] setScrollIndicatorInsets:edgeInsets];
    
    [[self scrollView] scrollRectToVisible:[self campoActivo].frame animated:YES];
}


- (void)textFieldDidBeginEditing:(UITextField *)textField
{
    [self setCampoActivo:textField];
}

- (void)textFieldDidEndEditing:(UITextField *)textField
{
    [self setCampoActivo:nil];
}



- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)buscar:(id)sender
{
    if([[txtCodigo text] isEqualToString:@""] & [[txtName text] isEqualToString:@""] & [[txtCodBarras text] isEqualToString:@""] & [[txtPrecio text] isEqualToString:@""] & [[txtUnidad text] isEqualToString:@""] ){
        NSString *alertString = [NSString stringWithFormat:@"Introduzca algún valor a buscar"];
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:alertString message:@"" delegate:self cancelButtonTitle:@"Aceptar" otherButtonTitles:nil];
        [alert show];
        //[self alertStatus:@"Formulario incompleto" :@"Introduzca todos los valores"];
    } else {
        // create string contains url address for php file, the file name is phpFile.php, it receives parameter :name
        NSString *strURL = [NSString stringWithFormat:@"http://pruebamarcos.xtrweb.com/buscar.php?codigo=%@&name=%@&codbarras=%@&precio=%@&unidad=%@", [txtCodigo.text stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding], [txtName.text stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding], [txtCodBarras.text stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding], [txtPrecio.text stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding], [txtUnidad.text stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding], nil];
        
        NSURL *url = [NSURL URLWithString:strURL];
        
        NSLog(@"%@", url);
        
        NSString *jsonreturn = [[NSString alloc] initWithContentsOfURL:url]; // Pulls the URL
        NSLog(@"El valor de jsonreturn es:%@",jsonreturn); // Look at the console and you can see what the restults are
        
        
        NSData *jsonData = [jsonreturn dataUsingEncoding:NSUTF32BigEndianStringEncoding];
        NSError *error = nil;
        
        // In "real" code you should surround this with try and catch
        NSDictionary * dict = [[CJSONDeserializer deserializer] deserializeAsDictionary:jsonData error:&error];
        
        NSLog(@"El valor de error es:%@",error);
        
        if (error == nil)
        {
            if (dict)
            {
                rows = [[dict objectForKey:@"user"] retain];
            }
            
            //NSIndexPath *indexPath;
            NSDictionary *dictnuevo = [rows objectAtIndex:0];
            txtId.text = [dictnuevo objectForKey:@"id"];
            txtCodigo.text = [dictnuevo objectForKey:@"codigo"];
            txtName.text = [dictnuevo objectForKey:@"name"];
            txtCodBarras.text = [dictnuevo objectForKey:@"codbarras"];
            txtPrecio.text = [dictnuevo objectForKey:@"precio"];
            txtUnidad.text = [dictnuevo objectForKey:@"unidad"];
            
            NSLog(@"Array: %@", [dictnuevo objectForKey:@"codigo"]);
            
        }
        else{
            
            
            NSString *alertString = [NSString stringWithFormat:@"Registro no encontrado"];
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:alertString message:@"" delegate:self cancelButtonTitle:@"Aceptar" otherButtonTitles:nil];
            [alert show];
            
            txtId.text=NULL;
            txtName.text=NULL;
            txtCodigo.text=NULL;
            txtCodBarras.text=NULL;
            txtPrecio.text=NULL;
            txtUnidad.text=NULL;
            
            
        }
        
    }
}


- (IBAction)borrar:(id)sender
{

    if([[txtId text] isEqualToString:@""]) {
        NSString *alertString = [NSString stringWithFormat:@"Introduzca los datos del producto a eliminar y pulse Buscar"];
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:alertString message:@"" delegate:self cancelButtonTitle:@"Aceptar" otherButtonTitles:nil];
        [alert show];
        //[self alertStatus:@"Formulario incompleto" :@"Introduzca todos los valores"];
    } else {
    
    
        // create string contains url address for php file, the file name is phpFile.php, it receives parameter :name
        NSString *strURL = [NSString stringWithFormat:@"http://pruebamarcos.xtrweb.com/borrar.php?id=%@",txtId.text];
        
        
        NSLog(@"valor de id:%@", txtId.text);
        
        // to execute php code
        NSData *dataURL = [NSData dataWithContentsOfURL:[NSURL URLWithString:strURL]];
        
        // to receive the returend value
        NSString *strResult = [[NSString alloc] initWithData:dataURL encoding:NSUTF8StringEncoding];
        
        
        
        NSLog(@"EL VALOR DE strResult ES:%@",strResult);
        

        NSString *alertString = [NSString stringWithFormat:@"Registro eliminado: %@", strResult];
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:alertString message:@"" delegate:self cancelButtonTitle:@"Aceptar" otherButtonTitles:nil];
        [alert show];
        
        txtId.text=NULL;
        txtName.text=NULL;
        txtCodigo.text=NULL;
        txtCodBarras.text=NULL;
        txtPrecio.text=NULL;
        txtUnidad.text=NULL;
    }

}



- (BOOL) shouldAutorotateToInterfaceOrientation: (UIInterfaceOrientation) orient
{
    return(YES);
}

- (void)dealloc
{
    [txtName release];
    [txtCodigo release];
    [txtCodBarras release];
    [txtPrecio release];
    [txtUnidad release];
    //[lId release];
    [codresultText release];
    [super dealloc];
}


@end

