//
//  ViewController.m
//  ControlStock
//
//  Created by Marcos on 5/7/13.
//  Copyright (c) 2013 Marcos. All rights reserved.
//

#import "VCInsertar.h"

@interface VCInsertar ()

@end

@implementation VCInsertar


@synthesize txtName, txtCodigo, txtCodBarras, txtPrecio, txtUnidad ,codresultText, resultImage;

- (void)viewDidLoad
{
    [super viewDidLoad];
    //scroller.frame = CGRectMake(0, 0, 320, 60);
    //[scroller setContentSize:CGSizeMake(1024, 768)];
	// Do any additional setup after loading the view, typically from a nib.
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(apareceElTeclado:)
                                                 name:UIKeyboardWillShowNotification
                                               object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(desapareceElTeclado:)
                                                 name:UIKeyboardWillHideNotification
                                               object:nil];
    [[self scrollView] setContentSize:[[self view] frame].size];
    
    UITapGestureRecognizer *tapRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(scrollViewPulsado)];
    [tapRecognizer setCancelsTouchesInView:NO];
    [[self scrollView] addGestureRecognizer:tapRecognizer];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    [[NSNotificationCenter defaultCenter] removeObserver:self
                                                    name:UIKeyboardWillShowNotification
                                                  object:nil];
    
    [[NSNotificationCenter defaultCenter] removeObserver:self
                                                    name:UIKeyboardDidHideNotification
                                                  object:nil];
}


- (void) scrollViewPulsado
{
    [[self view] endEditing:YES];
}


- (void) desapareceElTeclado:(NSNotification *)laNotificacion
{
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationDuration:0.3];
    UIEdgeInsets edgeInsets = UIEdgeInsetsZero;
    [[self scrollView] setContentInset:edgeInsets];
    [[self scrollView] setScrollIndicatorInsets:edgeInsets];
    [UIView commitAnimations];
}


- (void) apareceElTeclado:(NSNotification *)laNotificacion
{
    //Obtenemos el tamaño del teclado
    NSDictionary *infoNotificacion = [laNotificacion userInfo];
    CGSize tamanioTeclado = [[infoNotificacion objectForKey:UIKeyboardFrameBeginUserInfoKey] CGRectValue].size;
    
    //Modificamos el tamaño de la 'ventana' de nuestro scroll view
    UIEdgeInsets edgeInsets = UIEdgeInsetsMake(0, 0, tamanioTeclado.height, 0);
    [[self scrollView] setContentInset:edgeInsets];
    [[self scrollView] setScrollIndicatorInsets:edgeInsets];
    
    [[self scrollView] scrollRectToVisible:[self campoActivo].frame animated:YES];
}


- (void)textFieldDidBeginEditing:(UITextField *)textField
{
    [self setCampoActivo:textField];
}

- (void)textFieldDidEndEditing:(UITextField *)textField
{
    [self setCampoActivo:nil];
}



- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)insert:(id)sender
{

    if([[txtCodigo text] isEqualToString:@""] || [[txtName text] isEqualToString:@""]|| [[txtCodBarras text] isEqualToString:@""]|| [[txtPrecio text] isEqualToString:@""]|| [[txtUnidad text] isEqualToString:@""] ) {
        NSString *alertString = [NSString stringWithFormat:@"Formulario incompleto"];
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:alertString message:@"" delegate:self cancelButtonTitle:@"Aceptar" otherButtonTitles:nil];
        [alert show];
        //[self alertStatus:@"Formulario incompleto" :@"Introduzca todos los valores"];
    } else {

    
    
        NSString *strURL = [NSString stringWithFormat:@"http://pruebamarcos.xtrweb.com/insert.php?codigo=%@&name=%@&codbarras=%@&precio=%@&unidad=%@", [txtCodigo.text stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding], [txtName.text stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding], [txtCodBarras.text stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding], [txtPrecio.text stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding], [txtUnidad.text stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding], nil];

        NSLog(@"%@", strURL);
    
        // to execute php code
        NSData *dataURL = [NSData dataWithContentsOfURL:[NSURL URLWithString:strURL]];
    
        // to receive the returend value
        NSString *strResult = [[NSString alloc] initWithData:dataURL encoding:NSUTF8StringEncoding];
    
    
    
        NSLog(@"EL VALOR DE strResult ES:%@",strResult);

         NSString *alertString = [NSString stringWithFormat:@"Datos introducidos: %@", strResult];
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:alertString message:@"" delegate:self cancelButtonTitle:@"Aceptar" otherButtonTitles:nil];
        [alert show];

        
        txtName.text=NULL;
        txtCodigo.text=NULL;
        txtCodBarras.text=NULL;
        txtPrecio.text=NULL;
        txtUnidad.text=NULL;
    }
}


- (IBAction) scanButtonTapped
{
    // ADD: present a barcode reader that scans from the camera feed
    ZBarReaderViewController *reader = [ZBarReaderViewController new];
    reader.readerDelegate = self;
    reader.supportedOrientationsMask = ZBarOrientationMaskAll;
    
    ZBarImageScanner *scanner = reader.scanner;
    // TODO: (optional) additional reader configuration here
    
    // EXAMPLE: disable rarely used I2/5 to improve performance
    [scanner setSymbology: ZBAR_I25
                   config: ZBAR_CFG_ENABLE
                       to: 0];
    
    // present and release the controller
    [self presentModalViewController: reader
                            animated: YES];
    [reader release];
}

- (void) imagePickerController: (UIImagePickerController*) reader
 didFinishPickingMediaWithInfo: (NSDictionary*) info
{
    // ADD: get the decode results
    id<NSFastEnumeration> results =
    [info objectForKey: ZBarReaderControllerResults];
    ZBarSymbol *symbol = nil;
    for(symbol in results)
        // EXAMPLE: just grab the first barcode
        break;
    
    // EXAMPLE: do something useful with the barcode data
    codresultText.text=symbol.data;
    
    // EXAMPLE: do something useful with the barcode image
    resultImage.image =
    [info objectForKey: UIImagePickerControllerOriginalImage];
    
    // ADD: dismiss the controller (NB dismiss from the *reader*!)
    [reader dismissModalViewControllerAnimated: YES];
}

- (BOOL) shouldAutorotateToInterfaceOrientation: (UIInterfaceOrientation) orient
{
    return(YES);
}

- (void)dealloc
{
    [txtName release];
    [txtCodigo release];
    [txtCodBarras release];
    [txtPrecio release];
    [txtUnidad release];
    [_label release];
    [codresultText release];
    [super dealloc];
}


@end
